#!/usr/bin/perl

use strict;
use DBI;
use bigint;
use SNMP;

sub myGetOid {
	my($Host, $Community, $Oid, $Version)=@_;
	my($sess, $val);

	$sess = new SNMP::Session(DestHost => $Host, Community => $Community, Version => $Version);
	$val = $sess->get($Oid);
	return($val);
}

my($dbh, $sth, $Continue, $Query);
my($current32, $last32, $last64, $host, $oid);

$Continue=1;

while($Continue==1) {
	if(!$dbh) {
		$dbh = DBI->connect("DBI:mysql:database=cacti;host=localhost",
				    "cactiuser", "password",
				    {'RaiseError' => 1});
		$sth = $dbh->prepare("SELECT * from snmp_counter64 ORDER BY host, oid");
	}
	$sth->execute();
	while (my $r = $sth->fetchrow_hashref()) {
		$last32=$r->{'last32'};
		$last64=$r->{'last64'};
		$host=$r->{'host'};
		$oid=$r->{'oid'};
		$current32=&myGetOid($host, $r->{'community'}, $oid, $r->{'version'});
		if($current32=='NOSUCHINSTANCE') {
			$current32=0;
		}
		if($last32>$current32) {
			$last64 += (4294967295-$last32)+$current32;
		} else {
			$last64 += $current32-$last32;
		}
		$Query="UPDATE snmp_counter64 SET last32=$current32, last64='$last64' WHERE host='$host' AND oid='$oid'";
		$dbh->do($Query);
	}

	sleep(30);
}
